package com.kakaoent.cpdd.config.client1.configuration.properties;

import java.util.List;
import lombok.Getter;
import lombok.Setter;

public interface ConfigApiProperties {

    List<ApiProperty> getUnits();

    @Getter
    @Setter
    class ApiProperty {

        private String unitName;
        private String url;
    }

    default ApiProperty find(String unitName) {
        return getUnits().stream()
                    .filter(e -> e.getUnitName().equals(unitName))
                    .findFirst()
                    .orElseThrow(IllegalArgumentException::new);
    }

}
